/*--------------------------------------------------------------------------
 * COPYRIGHT (c) 2001-2003, Solid Information Technology.  All Rights Reserved.
 * NAME: licprep.c
 * PURPOSE:
 *     This is a C program generates license.c file from solid.lic file
 *
 * ------------------------------------------------------------------------
 */

#include <stdio.h>
#include <string.h>

#include "c.h"


/*##***********************************************************************\
 *
 *               main
 *
 */

int SS_CDECL main(int argc, char * argv[])
{

    FILE *InputFile = NULL; 
    FILE *OutputFile = NULL;
    char Line[1024]="";

    if(3 != argc) {
        printf("Usage: %s [licensefile] [outputfile]\n", argv[0]);
        return(-1);
    }

    /* Open licensefile */
    InputFile = fopen(argv[1], "r");
    if(!InputFile) {
        printf("Unable to open inputfile:%s", argv[1]);
        return(-1);
    }

    /* Open outputfile */
    OutputFile = fopen(argv[2], "w");
    if(!OutputFile) {
        printf("Unable to open outputfile:%s", argv[1]);
        return(-1);
    }

    /* Write header */
    fprintf(OutputFile, "char *lic_string = \"\\\n");

    /* Loop whole license file */
    while(!feof(InputFile)) {
        fgets(Line,1024, InputFile);

        if( Line[strlen(Line)-1] == '\n' ) {
            Line[strlen(Line)-1] = '\0';
        }

        if( Line[strlen(Line)-1] == '\r' ) {
            Line[strlen(Line)-1] = '\0';
        }

        if( Line[strlen(Line)-1] != '\\' ) {
            strcat(Line, "\\n\\");
        } 
        strcat(Line, "\n");
        fputs(Line, OutputFile);
    }

    /* Write footer */
    fprintf(OutputFile, "\";\n");

    fclose(OutputFile);
    fclose(InputFile);

    return 0;      
}
