-- ********************************************
-- master1.sql
-- Execute this script in the MASTER database.
-- Initializes the master with node name MASTER.
-- Also creates the table and the publication.
-- ********************************************

-- Create the catalog named "master_catalog". 
-- Give this node the name "master_node".
-- Register this node as a master, and not as a replica.
CALL SYNC_SETUP_CATALOG (
        'sync_demo_catalog',
        'master_node',
	1,
	0);
COMMIT WORK;

-- Set the catalog to be the current catalog.
SET CATALOG sync_demo_catalog;
COMMIT WORK;

-- Create the table that we will synchronize.
CREATE TABLE SYNCDEMO
(
	REPLICAID  INTEGER NOT NULL,
	ID         INTEGER NOT NULL,
	STATUS     INTEGER NOT NULL,
	INTDATA    INTEGER,
	TEXTDATA   CHAR(30),
	UPDATETIME TIMESTAMP,
	PRIMARY KEY (REPLICAID, ID, STATUS) 
);
ALTER TABLE SYNCDEMO SET SYNCHISTORY;
COMMIT WORK;

-- Create a publication that publishes all data of the SyncDemo table.
-- Note that CREATE PUBLICATION commands must be inside double quotes.
"CREATE PUBLICATION PUB_DEMO 
BEGIN
	RESULT SET FOR SYNCDEMO
	BEGIN 
		SELECT * FROM SYNCDEMO ;
	END
END";
COMMIT WORK;
