-- *********************************************************
-- proced1.sql
-- Creates a procedure for inserting data into the sample
-- table SYNCDEMO. 
--
-- Execute in both the MASTER and REPLICA DBs.
--
-- NOTE: THIS HAS NO VALIDATION RULES.  DUPLICATES ARE 
-- HANDLED BY IGNORING THE DUPLICATE INSERT.
-- *********************************************************

SET CATALOG sync_demo_catalog;

"CREATE PROCEDURE SYNCDEMO_INSERT
(MACHINEID INTEGER,
 ID INTEGER,
 INTDATA INTEGER,
 TEXTDATA CHAR(20),
 UPDATETIME TIMESTAMP,
 TARGETDB CHAR(1))
RETURNS
 (SUCCESS INTEGER, ROWS_AFFECTED INTEGER)

BEGIN 

DECLARE STATUS INTEGER ; 

IF TARGETDB = 'R' THEN
  STATUS := 1 ;
	ELSE IF TARGETDB = 'M' THEN
	  STATUS := 2;
	ELSE 
	  STATUS := -1;
	END IF;
END IF;

EXEC SQL PREPARE SYNCDEMO_INS
INSERT INTO SYNCDEMO (REPLICAID, ID, STATUS, INTDATA, TEXTDATA, UPDATETIME)
	VALUES(?,?,?,?,?,?);

EXEC SQL EXECUTE SYNCDEMO_INS USING (MACHINEID, ID, STATUS, INTDATA, 
	TEXTDATA, UPDATETIME);

SUCCESS := SQLSUCCESS;
ROWS_AFFECTED := SQLROWCOUNT;

EXEC SQL CLOSE SYNCDEMO_INS;

END";

COMMIT WORK;
