-- *********************************************************
-- proced2.sql
-- Creates a procedure for updating data of the sample
-- table SYNCDEMO. 
--
-- Execute in both the MASTER and REPLICA DBs.
--
-- VALIDATION RULE: IF TIMESTAMP HAS CHANGED, THEN UPDATE 
-- IS CHANGED TO INSERT WITH PARAMETER 'TARGETDB' AS 'F'.
-- THIS WILL RESULT IN AN INSERT WITH THE STATUS OF -1 IN
-- THE CALLED PROCEDURE SYNCDEMO_INSERT
-- *********************************************************

SET CATALOG sync_demo_catalog;

"CREATE  PROCEDURE SYNCDEMO_UPDATE
(
  MACHINEID INTEGER,
  ID INTEGER,
  INTDATA INTEGER,
  TEXTDATA CHAR(30),
  UPDATETIME TIMESTAMP,
  TARGETDB CHAR(1)
)
RETURNS
(SUCCESS INTEGER, ROWS_AFFECTED INTEGER)
BEGIN
  DECLARE DUMMY VARCHAR ;
  DECLARE TNOW TIMESTAMP;
  DECLARE DSTAT INTEGER ;
  DECLARE STATUS INTEGER ;

  IF TARGETDB = 'R' THEN
    STATUS := 1;
  ELSE
    STATUS := 2;
  END IF ; 

  TNOW := NOW();
  DUMMY := 'R';
  DSTAT := -1;

  EXEC SQL PREPARE SYNCDEMO_UPD
  UPDATE SYNCDEMO SET 
     STATUS = ?,
     INTDATA  = ?,
     TEXTDATA = ?,
     UPDATETIME = ?
  WHERE 
    REPLICAID = ? AND
    ID = ? AND 
    UPDATETIME = ? ;

  EXEC SQL EXECUTE SYNCDEMO_UPD USING     
    (STATUS, INTDATA, TEXTDATA, TNOW, MACHINEID, ID, UPDATETIME);

  SUCCESS := SQLSUCCESS ;
  ROWS_AFFECTED := SQLROWCOUNT;

  IF (SUCCESS = 1) AND (ROWS_AFFECTED = 0) THEN
    DUMMY := 'F' ;

    EXEC SQL PREPARE SYNC_UPD1 CALL SYNCDEMO_INSERT(?, ?, ?, ?, ?, ?);

    EXEC SQL EXECUTE SYNC_UPD1 
      USING (MACHINEID, ID, INTDATA, TEXTDATA, TNOW, DUMMY) ;
    EXEC SQL FETCH SYNC_UPD1 ;

    SUCCESS := SQLSUCCESS;
    ROWS_AFFECTED := SQLROWCOUNT;
  END IF ;

END";

COMMIT WORK;
