-- *******************************************************
-- replica1.sql
-- Initialize a replica database with node name 
-- "replica_node_01".
-- (Each replica must have a unique node name.)
-- Execute this script in the REPLICA database.
-- NOTE: AUTOCOMMIT must be set off for MESSAGE handling!
-- *******************************************************
-- Create a replica catalog named "replica_catalog" and
-- register it with the master database server called
-- "master_node". Also, specify the network address and name of the
-- master node, and specify the user ID and password to use.
CALL SYNC_REGISTER_REPLICA (
        'replica_node_01',
        'sync_demo_catalog',
        'tcp localhost 2315', -- Master's net address. CUSTOMIZE!
        'master_node', -- Node name of master.
        'dba',
        'dba');
COMMIT WORK;

SET CATALOG sync_demo_catalog;
COMMIT WORK;
	
-- Create the table.
CREATE TABLE SYNCDEMO
(
	REPLICAID  INTEGER NOT NULL,
	ID         INTEGER NOT NULL,
	STATUS     INTEGER NOT NULL,
	INTDATA    INTEGER,
	TEXTDATA   CHAR(30),
	UPDATETIME TIMESTAMP,
	PRIMARY KEY (REPLICAID, ID, STATUS) 
);
-- Enable the use of incremental publications for this table.
ALTER TABLE SYNCDEMO SET SYNCHISTORY;
COMMIT WORK;

-- Register a publication that is already defined in the master.
CALL SYNC_REGISTER_PUBLICATION (
        'sync_demo_catalog',
        'pub_demo');
COMMIT WORK;

