-- *********************************************************
-- replica3.sql
-- creates a new message with name 'my_msg' 
-- append tasks to message my_msg: propagate transactions
-- 			         : refresh publications
--
-- Execute in the REPLICA database.
--
-- NOTE: AUTOCOMMIT must be off!
-- *********************************************************

SET CATALOG sync_demo_catalog;

MESSAGE my_msg BEGIN ; 
MESSAGE my_msg APPEND PROPAGATE TRANSACTIONS ; 
MESSAGE my_msg APPEND REFRESH PUB_DEMO ; 
MESSAGE my_msg END ; 
COMMIT WORK ; 

-- Send the message to master, don't wait for reply.
MESSAGE my_msg FORWARD;
COMMIT WORK; 

-- Request reply to the message separately from master.
MESSAGE my_msg GET REPLY TIMEOUT DEFAULT ;
COMMIT WORK;
