-- STEP 01 (master) 
-- Initialize the master database and create user IDs for the system

SET SYNC NODE MASTER_DB ;
COMMIT WORK ; 

SET SYNC MASTER YES ; 
COMMIT WORK ; 


-- Set a persistent 'NODE_NAME' parameter to the transaction 
-- parameter bulletin board with value 'MASTER'. 
-- It indicates to the propagated transactions that the name of the 
-- server is 'MASTER' 
-- This parameter can be queried using the get_param() function. 
SET SYNC PARAMETER NODE_NAME 'MASTER' ;
COMMIT WORK ; 


-- Create users with different roles to the system

-- The app_user has rights that are needed to use the application and perform synchronization tasks
CREATE USER app_user IDENTIFIED BY app_user ; 
COMMIT WORK ; 

-- The reg_user has access to the replica registration functions only. 
CREATE USER reg_user IDENTIFIED BY reg_user ; 
GRANT sys_sync_register_role TO reg_user ; 
COMMIT WORK ; 

-- Now the master database is ready for accepting replica registrations
-- and other synchronization-related tasks 
