-- STEP 02 (replica) 
-- Initialize the replica database and register it with master database

-- Each replica must have a unique node name
-- AUTOCOMMIT MUST BE OFF!
SET SYNC NODE REPLICA1;
COMMIT WORK;
SET SYNC REPLICA YES;
COMMIT WORK;

CREATE USER app_user IDENTIFIED BY app_user ; 
COMMIT WORK ; 

-- Set a persistent 'NODE_NAME' parameter to the bulletin board with value 'REPLICA1'. 
-- This parameter can be queried using the get_param() function. 
SET SYNC PARAMETER NODE_NAME 'REPLICA1' ;
COMMIT WORK ; 
 
-- Use the "reg_user" user ID for registering the new replica
SET SYNC USER reg_user IDENTIFIED BY reg_user ; 
COMMIT WORK;

 
-- register the replica with the master by sending a registration message
MESSAGE cfg1 BEGIN;
MESSAGE cfg1 APPEND REGISTER REPLICA;
MESSAGE cfg1 END;
COMMIT WORK;

-- edit this line to match master server's network name
MESSAGE cfg1 FORWARD TO 'tcp 2315' TIMEOUT FOREVER;
COMMIT WORK;
 
-- Subscribe user account information from master in a separate message
MESSAGE cfg2 BEGIN ;
MESSAGE cfg2 APPEND SYNC_CONFIG('%');
MESSAGE cfg2 END;
COMMIT WORK;

-- edit this line to match master server's network name
MESSAGE cfg2 FORWARD TO 'tcp 2315' TIMEOUT FOREVER;
COMMIT WORK;

SET SYNC USER NONE;
COMMIT WORK;

-- Now the replica database has been registered with the master database
