-- STEP 04 (master) 
-- Define the publication that is used in this sample system.
-- Run this script only in the master database. 

-- This sample has one publication that can be used for 
-- subscribing customers & related data to replica
-- database using the customer area code as a search criterion. 
 
"CREATE PUBLICATION customers_by_area (areacode VARCHAR) 
BEGIN 
	RESULT SET FOR customer
	BEGIN 
		SELECT * 
		FROM customer
		WHERE area = :areacode  ;
		
		RESULT SET FOR order
		BEGIN 
			SELECT * 
			FROM ORDER 
			WHERE customer_id = customer.id  ;
		END 

		DISTINCT RESULT SET FOR account
		BEGIN
			SELECT * 
			FROM account
			WHERE number = customer.account_number ;
		END  
	END  
	RESULT SET FOR err_log 
	BEGIN 
		SELECT * 
		FROM err_log ; 
	END 
END" ; 
COMMIT WORK ;

-- grant read rights to app_user to use this publication
GRANT REFRESH ON customers_by_area TO app_user ; 
COMMIT WORK ;
 
