-- COPYRIGHT: Copyright (c) 2002, Solid Information Technology.
-- TITLE: SetUpMaster.SQL
-- PURPOSE: This is part of a sample that shows how to implement  
--     Sync Pull Notify (push Synchronization)


-- Create the table(s) that will be used in the publication.  
CREATE TABLE customers (
	id INT NOT NULL,
	name VARCHAR(30),
	address VARCHAR(100), 
	PRIMARY KEY (id)
	);

COMMIT WORK;


-- Specify that this node is a "master" node.
SET SYNC NODE MASTER;
SET SYNC MASTER YES;
SET SYNC REPLICA NO;
COMMIT WORK;


-- Create the publication that the replica can subscribe to.  
"CREATE PUBLICATION publication1
BEGIN
    RESULT SET FOR customers
    BEGIN
        SELECT * FROM customers;
    END
END";

COMMIT WORK;




-- Create the trigger that contains the START AFTER COMMIT.
-- Note that "in the real world" you would almost always 
-- create UPDATE and DELETE triggers as well as an INSERT trigger, 
-- but we've limited this sample to one trigger for simplicity.  
"CREATE TRIGGER cust_insert_trig
 ON customers AFTER INSERT
BEGIN

-- When the current transaction is committed, call the 
-- routine on the replica(s) that will request a refresh of the 
-- updated data.  
EXEC SQL EXECDIRECT START AFTER COMMIT UNIQUE 
 CALL refresh_from_publication1 AT replica1;

END";

COMMIT WORK;
