-- ***********************************************
-- THE SAMPLE ANSWER TO EXERCISE TASK 1
-- 
-- PROCEDURE INSERT_CUSTOMER
--
-- ***********************************************

-- initialize the exercise tables
DELETE FROM CUSTOMER;
DELETE FROM PRODUCT;
DELETE FROM ORDER;
DELETE FROM ORDER_LINE;

COMMIT WORK;

DROP SEQUENCE customer_ids;
COMMIT WORK;
CREATE SEQUENCE customer_ids; 
COMMIT WORK;

DROP PROCEDURE INSERT_CUSTOMER ; 
COMMIT WORK;

"CREATE PROCEDURE INSERT_CUSTOMER (pname varchar, paddress varchar, 
	pcredit_limit decimal(12,2), override_duplicate_check integer)
RETURNS (psuccess integer, pid integer)
BEGIN 
	DECLARE tmpname VARCHAR ; 
	DECLARE tmpaddress VARCHAR ; 
	
	EXEC SQL WHENEVER SQLERROR ABORT ; 
	psuccess := 1 ; 
	pid := 0 ; 
-- check whether there already exists a customer with similar 
	IF override_duplicate_check = 0 THEN 	
		tmpname := pname + '%' ; 
		tmpaddress := paddress + '%' ; 
		EXEC SQL PREPARE c_check_duplicate 	
			SELECT * 
			FROM CUSTOMER 
			WHERE name LIKE ? AND address LIKE ? ; 
		EXEC SQL EXECUTE c_check_duplicate USING (tmpname, tmpaddress) ; 
		EXEC SQL FETCH c_check_duplicate ; 
		IF SQLSUCCESS = 1 THEN 
			psuccess := -1 ; 
			EXEC SQL DROP c_check_duplicate ; 
			RETURN ; 
		END IF ; 
		EXEC SQL DROP c_check_duplicate ; 
	END IF ; 
	
	EXEC SEQUENCE customer_ids.next INTO pid ; 
	EXEC SQL PREPARE c_ins_customer 
		INSERT INTO CUSTOMER (id, name, address, used_credit, credit_limit) 
		VALUES (?,?,?,0,?) ; 
	EXEC SQL EXECUTE c_ins_customer USING (pid, pname, paddress, pcredit_limit) ; 
	EXEC SQL CLOSE c_ins_customer ; 
	EXEC SQL DROP c_ins_customer ; 

END ";

COMMIT WORK;

call insert_customer ('Joe Cool' , 'Cupertino, CA', 10000, 0); 
call insert_customer ('Charlie Brown' , 'Cupertino, CA', 20000, 1); 
select * from customer ; 

COMMIT WORK;

-- ***********************************************
-- THE SAMPLE ANSWER TO EXERCISE TASK 1, CONT.
-- 
-- PROCEDURE INSERT_ORDER
--
-- ***********************************************

DROP SEQUENCE ORDER_IDS;
COMMIT WORK;
CREATE SEQUENCE ORDER_IDS ; 
COMMIT WORK;

DROP PROCEDURE INSERT_ORDER ; 
COMMIT WORK;

"CREATE PROCEDURE INSERT_ORDER 
	(pcustomer_id integer, 
	pstatus varchar,
	porder_date date, 
	porder_value decimal(12,2), 
	poverride_check integer)
RETURNS (psuccess integer, pid integer)
BEGIN 
	DECLARE used_credit DECIMAL (12,2) ; 
	DECLARE credit_limit DECIMAL (12,2) ; 

	EXEC SQL WHENEVER SQLERROR ABORT ; 
	psuccess := 1 ; 
	pid := 0 ; 

-- check whether the customer exists 
	EXEC SQL PREPARE c_check_customer	
		SELECT used_credit, credit_limit 
		FROM CUSTOMER 
		WHERE ID = ? ; 
	EXEC SQL EXECUTE c_check_customer USING (pcustomer_id) INTO (used_credit, credit_limit) ; 
	EXEC SQL FETCH c_check_customer; 
	IF SQLSUCCESS = 0 THEN 
		psuccess := -1 ; 
		EXEC SQL DROP c_check_customer ; 
		RETURN ; 
	END IF ;  

	EXEC SQL DROP c_check_customer ; 

-- check whether the credit limit of the customer is not exceeded
	IF (used_credit + porder_value > credit_limit) AND (poverride_check = 0) THEN 
		psuccess := -1 ; 
		RETURN ; 
	END IF ; 
		 
	EXEC SEQUENCE order_ids.next INTO pid ; 
	EXEC SQL PREPARE c_ins_order 
		INSERT INTO ORDER (id, customer_id, status, order_date, order_value) 
		VALUES (?,?,?,?,?) ; 
	EXEC SQL EXECUTE c_ins_order USING (pid, pcustomer_id, pstatus, porder_date, porder_value) ; 
	EXEC SQL CLOSE c_ins_order ; 
	EXEC SQL DROP c_ins_order ; 

-- update the customer credit with the total amount of the order
	EXEC SQL PREPARE c_upd_cust_credit 
		UPDATE customer 
		SET used_credit = used_credit + ? 
		WHERE id = ? ; 
	EXEC SQL EXECUTE c_upd_cust_credit USING (porder_value, pcustomer_id) ; 
	EXEC SQL CLOSE c_upd_cust_credit ; 
	EXEC SQL DROP c_upd_cust_credit ; 

END ";
COMMIT WORK;

--should fail: there is no customer 7
CALL INSERT_ORDER (7, 'NEW', '1998-12-07', 10000, 1) ;
--should be OK: the sequencer has created customer 1 
CALL INSERT_ORDER (1, 'NEW', '1998-12-07', 5000, 1) ;
select * from customer ; 
COMMIT WORK;

-- ***********************************************
-- THE SAMPLE ANSWER TO EXERCISE TASK 1, CONT.
-- 
-- PROCEDURE INSERT_ORDER_LINE
--
-- ***********************************************

DROP EVENT inventory_event;
COMMIT WORK;
CREATE EVENT inventory_event (event_type varchar, event_message varchar) ; 
COMMIT WORK;

DROP PROCEDURE INSERT_ORDER_LINE ; 
COMMIT WORK;

"CREATE PROCEDURE INSERT_ORDER_LINE 
	(porder_id integer, 
	prow_num varchar,
	pproduct_id integer, 
	pordered_amount decimal(12,2)) 
RETURNS (psuccess integer)
BEGIN 
	DECLARE amount_in_stock DECIMAL(12,2) ; 
	DECLARE alert_limit DECIMAL(12,2) ; 
	DECLARE tmpstr1 VARCHAR ; 
	DECLARE tmpstr2 VARCHAR ; 

	EXEC SQL WHENEVER SQLERROR ABORT ; 
	psuccess := 1 ; 

-- verify that the product of the order line exists 
	EXEC SQL PREPARE c_check_product	
		SELECT amount_in_stock, alert_limit
		FROM product 
		WHERE id = ? ; 
	EXEC SQL EXECUTE c_check_product USING (pproduct_id) INTO (amount_in_stock, alert_limit) ; 
	EXEC SQL FETCH c_check_product; 
	IF SQLSUCCESS = 0 THEN 
		psuccess := -1 ; 
		EXEC SQL DROP c_check_product ; 
		RETURN ; 
	END IF ;  
	EXEC SQL DROP c_check_product ; 

-- verify that the order of the order line exists
	EXEC SQL PREPARE c_check_order	
		SELECT *
		FROM order 
		WHERE id = ? ; 
	EXEC SQL EXECUTE c_check_order USING (porder_id)  ; 
	EXEC SQL FETCH c_check_order ; 
	IF SQLSUCCESS = 0 THEN 
		psuccess := -1 ; 
		EXEC SQL DROP c_check_order ; 
		RETURN ; 
	END IF ;  
	EXEC SQL DROP c_check_product ; 

	EXEC SQL PREPARE c_ins_order_line 
		INSERT INTO order_line (order_id, row_num, product_id, ordered_amount) 
		VALUES (?,?,?,?) ; 
	EXEC SQL EXECUTE c_ins_order_line USING (porder_id, prow_num, pproduct_id, pordered_amount) ; 
	EXEC SQL DROP c_ins_order_line ; 

-- If the amount_in_stock goes below the alert_limit with this order_line, launch an event that informs the managing workstation 
-- about the need to backorder 

	tmpstr1 := 'PROCURE' ; 
	tmpstr2 := 'PRODUCT #' + convert_char (pproduct_id) ; 

	IF (amount_in_stock - pordered_amount < alert_limit) AND (amount_in_stock > alert_limit) THEN 
		POST EVENT inventory_event (tmpstr1, tmpstr2) ; 
	END IF ; 

-- update the amount_in_stock value of the ordered product
	EXEC SQL PREPARE c_update_prod_stockbal 
		UPDATE product
		SET amount_in_stock = amount_in_stock - ?
		WHERE id = ? ; 
	EXEC SQL EXECUTE c_update_prod_stockbal USING (pordered_amount, pproduct_id) ; 
	EXEC SQL DROP c_update_prod_stockbal ; 

END ";

COMMIT WORK;

INSERT INTO PRODUCT VALUES (1, 'Hammer', 10, 30, 5) ;

-- should fail: there is no order 6
CALL  insert_order_line (6,1,1,30);

-- should be OK: we have created order 1 for customer 1
CALL  insert_order_line (1,1,1,10);

-- should be OK: customer exists, but causes an backorder event
CALL  insert_order_line (1,2,1,40);

SELECT * FROM ORDER_LINE;
SELECT * FROM PRODUCT;
SELECT * FROM SYS_EVENTS;

COMMIT WORK;
