-- ****************************************
-- THIS SCRIPT CREATES THE DATA
-- MODEL FOR THE EXERCISES DESCRIBED
-- IN COURSE_EXERCISES.TXT
-- ****************************************
drop table customer; 
create table customer
	(id integer not null primary key, 
	name varchar not null, 
	address varchar not null, 
	used_credit decimal (10,2), 
	credit_limit decimal (10,2)) ; 

drop table order; 
create table order 
	(id integer not null primary key, 
	customer_id integer not null, 
	status varchar,
	order_date date, 
	order_value decimal(12,2)) ; 

drop table order_line; 
create table order_line 
	(order_id integer not null, 
	row_num integer not null, 
	product_id integer not null, 
	ordered_amount decimal(12,2) not null, 
	primary key (order_id, row_num)) ; 

drop table product; 
create table product 
	(id integer not null primary key, 
	product_name varchar not null, 
	product_price decimal(12,2) not null, 
	amount_in_stock decimal(12,2) not null, 
	alert_limit decimal (12,2) not null ) ;

drop table alerts; 
create table alerts
	(alert_id integer not null primary key,
	createtime timestamp not null, 
	status varchar not null, 
	alert_type varchar not null,
	alert_text varchar not null) ;

drop table daily_order_report; 
create table daily_order_report 
	(report_date date not null, 
	row_num integer not null, 
	product_id integer, 
	product_name varchar, 
	amount_ordered_today decimal(12,2),
	primary key (report_date, row_num)) ; 
	
commit work;