package testclient; 

import javax.ejb.*;
import javax.naming.*;
import java.rmi.*;
import java.util.Properties;
import solidtest.server.*;

public class SolidTestClient 
{ 
  
    public static void main(String[] args) {
        System.out.println("\nBegin DemoClient...\n");
  
        parseArgs(args);
        try {
            Context ctx = getInitialContext();
            SolidTestHome dhome = (SolidTestHome)ctx.lookup("ejb.SolidTestRemoteHome");
  
            System.out.println("Creating Demo\n");
            SolidTest demo = dhome.create();
  
			System.out.print("Calling getTableNames() in the remote object ... ");
            SolidTableNames stn = demo.getTableNames();
			System.out.println("OK.\n");
			
			System.out.println("Dumping Solid Table Names:");
			System.out.println("--------------------------");
			stn.dumpNames(System.out);
  
        } catch (Exception e) {
            System.out.println(" => Error <=");
            e.printStackTrace();
        }
        System.out.println("\nEnd DemoClient...\n");
  }
  
  static void parseArgs(String args[]) {
    if ((args == null) || (args.length == 0))
      return;
    for (int i = 0; i < args.length; i++) {
      if (args[i].equals("-url"))
        url = args[++i];
      else if (args[i].equals("-user"))
        user = args[++i];
      else if (args[i].equals("-password"))
        password = args[++i];
    }
  }
  
  static String user = null;
  static String password = null;
  static String url = "t3://localhost:7001";
  
   /**
   * Gets an initial context.
   *
   * @return Context
   * @exception java.lang.Exception if there is
   * an error in getting a Context
   */
  static public Context getInitialContext() 
      throws Exception {
    Properties p = new Properties();
    p.put(Context.INITIAL_CONTEXT_FACTORY,
      "weblogic.jndi.T3InitialContextFactory");
    p.put(Context.PROVIDER_URL, url);
    if (user != null) {
      System.out.println ("user: " + user);
      p.put(Context.SECURITY_PRINCIPAL, user);
      if (password == null)
        password = "";
      p.put(Context.SECURITY_CREDENTIALS, password);
    }
    return new InitialContext(p);
  }
}

