package solidtest.server;

import solid.jdbc.SolidConnectionPoolDataSource;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import javax.sql.DataSource;
import javax.naming.Context;
import javax.naming.InitialContext;

/**
 * Bean implementation class for Enterprise Bean: SolidTest
 */
public class SolidTestBean implements javax.ejb.SessionBean {
	
	private final static String DEFAULT_UNAME = "DBA";
	private final static String DEFAULT_PWD = "DBA";
	private final static String DEFAULT_URL = "jdbc:solid://localhost:1313";
	
	private String userName_ = null;
	private String passWord_ = null;
	private String url_ = null;
	
	private Connection conn_ = null;
	
	private javax.ejb.SessionContext mySessionCtx;
	/**
	 * getSessionContext
	 */
	public javax.ejb.SessionContext getSessionContext() {
		return mySessionCtx;
	}
	/**
	 * setSessionContext
	 */
	public void setSessionContext(javax.ejb.SessionContext ctx) {
		mySessionCtx = ctx;
	}
	/**
	 * ejbCreate
	 */
	public void ejbCreate() throws javax.ejb.CreateException {
	}
	/**
	 * ejbActivate
	 */
	public void ejbActivate() {
	}
	/**
	 * ejbPassivate
	 */
	public void ejbPassivate() {
	}
	/**
	 * ejbRemove
	 */
	public void ejbRemove() {
	}
	
	private void createConnection() throws Exception {
		
		if ( (conn_==null) || (conn_.isClosed() == true) ){
			
			Context ctx = new InitialContext();
			
			DataSource ds = (DataSource) ctx.lookup("SolidDataSource");
			
// 			if (url_ != null){
// 				((SolidConnectionPoolDataSource)ds).setURL(url_);
// 			}

			if (userName_ == null){
				userName_ = DEFAULT_UNAME;
			}
			if (passWord_ == null){
				passWord_ = DEFAULT_PWD;
			}
			
// 			conn_ = ds.getConnection(userName_, passWord_);
			conn_ = ds.getConnection();
		}
	}
	
	public void setUsername( String uname ){
		userName_ = uname; 
	}
	
	public void setPassword( String pwd ){
		passWord_ = pwd;
	}
	
	public void setURL( String url ){
		url_ = url;
	}
	
	public SolidTableNames getTableNames(){
		
		SolidTableNames stn = new SolidTableNames();
		
		try {
			createConnection();
			stn.fillNames(conn_);
		} catch ( Exception e ){
			stn.fillException(e);
		}
		
		return stn;
	}	
}
